// 100 puncte
// Implementare - Constantin Galatan
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>
#include <vector>
#include <map>
using namespace std;

#define DIM 50
#define pb push_back
#define mp make_pair

ifstream fin("mxl.in");
ofstream fout("mxl.out");

int N, K;
string Tab[DIM][DIM];

struct State {
    int i, j;
    string expr;
    State(int _i,int _j, string _expr)
        : i(_i), j(_j), expr(_expr)
    {
    }
    bool operator< (const State& st) const
    {
		return expr < st.expr;
	}
};

map<State, long long> memo;
vector<pair<int, int> > cells;

void Read();
long long Value(int i, int j, string expr);
void Solve();
void Write();

int main()
{
	Read();
	Solve();
	Write();

	return 0;
}

void Write()
{
	for ( int i = 1; i <= N; ++i)
	{
		for ( int j = 1; j <= N; ++j )
			fout << memo[State(i, j, Tab[i][j])] << ' ';
		fout << '\n';
	}
	fout.close();
}

void Read()
{
	fin >> N >> K;
	int i, j;
	string expr;
	for ( int k = 0; k < K; ++k )
	{
		fin >> i >> j; fin.get();
		cells.pb(mp(i, j));
		getline(fin, expr);
		Tab[i][j] = expr;
	}
	fin.close();
}

void Solve()
{
	int i, j;
	for (int c = 0; c < (int)cells.size(); c++ )
	{
		i = cells[c].first; j = cells[c].second;
		Value(i, j, Tab[i][j]);
	}
}

long long Value(int i, int j, string expr)
{
    State s(i, j, expr);
    if ( memo.find(s) != memo.end())
        return memo[s];

    if ( expr[0] == '=' )
		return memo[s] = Value(i, j, expr.substr(1));

	if ( expr.find_first_of("+:") == string::npos) // nu apare + sau :
	{
		int x = atoi(expr.c_str()); // deci e numar
		return memo[s] = x;
	}

	// daca expresia nu incepe cu = , caut +
	int poz_plus = expr.find('+');
	if ( poz_plus != (int)string::npos ) // am gasit un +
	{
		string t = expr.substr(0, poz_plus);

		if ( t.find_first_of("+:") == string::npos) // daca primul termenul e  numar
		{
			long x = atol(t.c_str());
			memo[s] = x;
		}
		else // primul termen e referinta
		{
			int poz_doua_puncte = t.find(':');
			int ii = atoi(t.substr(0, poz_doua_puncte).c_str());
			int jj = atoi(t.substr(poz_doua_puncte + 1, poz_plus - poz_doua_puncte - 1).c_str());
			memo[s] = Value(ii, jj, Tab[ii][jj]);
		}

		memo[s] += Value(i, j, expr.substr(poz_plus + 1));
	}
	else // expr e referinta (numar nu poate fi - s-a tratat cazul la intrare)
	{
		int poz_doua_puncte = expr.find(':');
		int ii = atoi(expr.substr(0, poz_doua_puncte).c_str());
		int jj = atoi(expr.substr(poz_doua_puncte + 1, poz_plus - poz_doua_puncte - 1).c_str());
		memo[s] = Value(ii, jj, Tab[ii][jj]);
	}

	return memo[s];
}
