/* 

	implementare Dan Pracsiu (70 puncte)
	O(nV * nV * nH * log 1000 000 000)
 
 */
#include<fstream>
#define InFile "segmente.in"
#define OutFile "segmente.out"

using namespace std ;

struct segment
{
	int x1, y1, x2, y2 ;
};

segment V[1001] ; // memorez segmentele verticale
segment H[1001] ; // memorez segmentele orizontale
int nV, nH ; // numar segmente verticale si orizontale
int lungimeMinima ;

void Citire()
{
	int i, n, a, b, c, d, aux; 
	
	ifstream fin(InFile) ;
	fin >> n ;
	for (i = 1 ; i <= n ; i++)
	{
		fin >> a >> b >> c >> d ;
		if (b == d) // segment orizontal
		{
			if (a > c) {aux = a; a = c; c = aux;}
			H[nH].y1 = H[nH].y2 = b ; 
			H[nH].x1 = a ; 
			H[nH].x2 = c ; 
			nH++ ;
		}
		else // segment vertical
		{
			if (b > d) {aux = b; b = d; d = aux;}
			V[nV].x1 = V[nV].x2 = a ;
			V[nV].y1 = b ;
			V[nV].y2 = d ;
			nV++ ;
		}
	}
	fin.close() ;
}

// sortez segmentele verticale crescator dupa abscisa
void SortV()
{
	int i, j ;
	segment s ;
	for (i = 0 ; i < nV - 1 ; i++)
		for (j = i + 1 ; j < nV ; j++)
			if (V[i].x1 > V[j].x1)
			{
				s = V[i] ;
				V[i] = V[j] ;
				V[j] = s ;
			}
}

inline int Maxim(int a, int b)
{
	if (a > b) return a ;
	return b ;
}

inline int Minim(int a, int b)
{
	if (a < b) return a ;
	return b ;
}

// caut daca se formeaza un dreptunghi daca lungesc segmentele cu valoarea val
int Cauta(int val)
{
	int i, j, p, jos, sus, contor ;
	for (i = 0 ; i < nV - 1 ; i++)
		for (j = i + 1 ; j < nV ; j++)
		{
			jos = Maxim(V[i].y1 - val, V[j].y1 - val) ;
			sus = Minim(V[i].y2 + val, V[j].y2 + val) ;
			if (jos < sus)
			{
				contor = 0 ;
				for (p = 0 ; (p < nH) && (contor < 2) ; p++)
					if ( (H[p].x1 - val <= V[i].x1) && (H[p].x2 + val >= V[j].x1) 
						&& (H[p].y1 >= jos) && (H[p].y1 <= sus) )
						contor++ ;
				if (contor >= 2)
					return 1 ;
			}
		}
	return 0 ;
}

// caut binar valoarea minima de lungit segmentele
void CautareBinara()
{
	int st, dr, mij ;
	st = 1 ; dr = 1000000000 ;
	while (st <= dr)
	{
		mij = (st + dr) / 2 ;
		if (Cauta(mij) == 1) 
		{	
			lungimeMinima = mij ;
			dr = mij - 1 ;
		}
		else st = mij + 1 ;
	}
}

void Solutie()
{
	ofstream fout(OutFile) ;
	fout << lungimeMinima << "\n" ;
	fout.close() ;
}

int main()
{
	Citire() ;
	SortV() ;
	CautareBinara() ;
	Solutie() ;
	
	return 0 ;
}
