//Tibi Savin
//O(N + M)

#include <stdio.h>
#include <vector>

using namespace std;

#define NMAX 200002

int N, M, R; // R e nodul fictiv
vector< pair<int, int> > G[NMAX];
int gr[NMAX];
int winner[NMAX];
int used_edges[NMAX];
int used_nodes[NMAX];
int position;

void euler(int nod) {
  used_nodes[nod] = 1;

  for (int i = 0; i < G[nod].size(); i++) {
    int node, edge;

    node = G[nod][i].first;
    edge = G[nod][i].second;

    if (used_edges[edge]) {
      continue;
    }

    used_edges[edge] = 1;
    euler(node);
    winner[edge] = node;
  }
}

int main() {
  freopen("fotbal.in", "r", stdin);
  freopen("fotbal.out", "w", stdout);

  scanf("%d %d ", &N, &M);

  for (int i = 1; i <= M; i++) {
    int x, y;
    scanf("%d %d ", &x, &y);

    G[x].push_back(make_pair(y, i));
    G[y].push_back(make_pair(x, i));

    gr[x]++;
    gr[y]++;
  }

  R = 0;
  int score_diff = 0;
  int cnt = M;
  for (int i = 1; i <= N; i++) {
    if (gr[i] % 2 == 1) {
      score_diff = 2;
      G[R].push_back(make_pair(i, ++cnt));
      G[i].push_back(make_pair(R, cnt));
    }
  }

  for (int i = 0; i <= N; i++) {
    if (!used_nodes[i]) {
      euler(i);
    }
  }

  printf("%d\n", score_diff);
  for (int i = 1; i <= M; i++) {
    printf("%d\n", winner[i]);
  }

  return 0;
}
