#include <iostream>
#include <fstream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

const char iname[] = "posta.in";
const char oname[] = "posta.out";

const int MAX_N = 100005;
const int MAX_C = 100000;

typedef long long i64;

vector < pair <int, int> > adj[MAX_N];    int nodes, inodes;
vector <int> cst, im, vis, cntv;


pair <int, i64> go(int u) {
    vis[u] = true;

    vector <pair <int, int> >::iterator it;
    i64 cost = 0;

    for (it = adj[u].begin(); it != adj[u].end(); ++ it) {
        int v = (*it).first;
        if (vis[v] == false) {
            pair <int, i64> ret = go(v);
            if (ret.first == false)
                continue ;
            cost += ret.second + (*it).second * 2;
            cntv[u] ++;
        }
    }
    cost += cntv[u] * cst[u];

    return make_pair(im[u] || cost, cost);
}

int main()
{
    FILE *fi = fopen(iname, "r");
    assert(fscanf(fi, "%d %d", &nodes, &inodes) == 2);
    assert(1 <= nodes && nodes <= MAX_N - 5);
    assert(1 <= inodes && inodes <= nodes);
    for (int i = 1; i < nodes; ++ i) {
        int u, v, cst;
        assert(fscanf(fi, "%d %d %d", &u, &v, &cst) == 3);
        assert(1 <= u && u <= nodes);
        assert(1 <= v && v <= nodes);
        assert(1 <= cst && cst <= MAX_C);
        adj[u].push_back(make_pair(v, cst));
        adj[v].push_back(make_pair(u, cst));
    }
    cst.resize(nodes + 1);
    for (int i = 1; i <= nodes; ++ i) {
        assert(fscanf(fi, "%d", &cst[i]) == 1);
        assert(1 <= cst[i] && cst[i] <= MAX_C);
    }
    im.resize(nodes + 1);
    im.assign(im.size(), 0);
    int start = 0;
    for (int i = 1; i <= inodes; ++ i) {
        int u;
        assert(fscanf(fi, "%d", &u) == 1);
        assert(1 <= u && u <= nodes);
        im[u] = true;
        start = u;
    }
    fclose(fi);

    vis.resize(nodes + 1);
    vis.assign(vis.size(), 0);
    cntv.resize(nodes + 1);
    cntv.assign(cntv.size(), 0);
    pair <int, i64> ret = go(start);

    assert(ret.first == true);
    ret.second -= cst[start];

    i64 minres = 1LL << 62;
    for (int i = 1; i <= nodes; ++ i) if (cntv[i])
        minres = min(minres, ret.second - ((i64) (cntv[i])) * cst[i]);

    fprintf(fopen(oname, "w"), "%lld\n", minres);

    return 0;
}

