/* Tataroiu Bogdan-Cristian - 60 de puncte */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#define MAXN 3000
#define MAXP 4000
#define MOD 31333

int N, P, mx[MAXN - 1], my[MAXN - 1], deg[MAXN];
int pow2[MAXN], treeSize[MAXN], val[MAXN], sum[MAXN];
int *con[MAXN], **cnt, **aux;

void dfs(int k, int p) {
    int *it, leaf = 1;
    treeSize[k] = 1;
    sum[k] = val[k];
    for (it = con[k]; *it != -1; it++) {
        if (*it == p) {
            continue;
        }

        dfs(*it, k);
        leaf = 0;
        treeSize[k] += treeSize[*it];
        sum[k] += sum[*it];
    }

    if (leaf) {
        memset(cnt[k], 0, sizeof(int) * P);
        cnt[k][val[k] - 1] = 1;
        return;
    }

    memset(aux[0], 0, sizeof(int) * P);
    aux[0][val[k] - 1] = 1;
    int step = 0, i, j;
    for (it = con[k]; *it != -1; it++) {
        if (*it == p) {
            continue;
        }
        for (i = 0; i < P; i++) {
            aux[1 ^ step][i] = (aux[step][i] * pow2[treeSize[*it] - 1]) % MOD;
        }

        for (i = 0; i < P; i++) {
            if (!aux[step][i]) {
                continue;
            }
            for (j = 0; i + j + 1 < P && j < sum[*it]; j++) {
                if (!cnt[*it][j]) {
                    continue;
                }
                aux[1 ^ step][i + j + 1] = (aux[1 ^ step][i + j + 1] +
                                            aux[step][i] * cnt[*it][j]) % MOD;
            }
        }
        step ^= 1;
    }
    memcpy(cnt[k], aux[step], sizeof(int) * P);
}

int main() {
    assert(freopen("radare.in", "rt", stdin));
    assert(freopen("radare.out", "wt", stdout));

    assert(scanf("%d %d", &N, &P) == 2);
    assert(1 <= N && N <= MAXN);
    assert(1 <= P && P <= MAXP);
    int i;
    /* Calculeaza 2^i % MOD pentru i intre 0 si N - 1 */
    pow2[0] = 1;
    for (i = 1; i < N; i++) {
        pow2[i] = (pow2[i - 1] << 1);
        if (pow2[i] >= MOD) {
            pow2[i] -= MOD;
        }
    }
    /* Citeste muchiile */
    for (i = 0; i + 1 < N; i++) {
        assert(scanf("%d %d", mx + i, my + i) == 2);
        assert(1 <= mx[i] && mx[i] <= N);
        assert(1 <= my[i] && my[i] <= N && mx[i] != my[i]);
        mx[i] -= 1; my[i] -= 1;
        deg[mx[i]] += 1;
        deg[my[i]] += 1;
    }
    /* Aloca memorie pentru muchiile fiecarui nod */
    for (i = 0; i < N; i++) {
        con[i] = malloc(sizeof(int) * (deg[i] + 1));
        con[i][deg[i]] = -1;
    }
    for (i = 0; i + 1 < N; i++) {
        con[mx[i]][--deg[mx[i]]] = my[i];
        con[my[i]][--deg[my[i]]] = mx[i];
    }

    /* Aloca memorie pentru cnt - dimensiune N x (P + 1) */
    cnt = malloc(sizeof(int *) * N);
    for (i = 0; i < N; i++) {
        cnt[i] = malloc(sizeof(int) * P);
    }
    /* Aloca memorie pentru aux - dimensiune 2 x (P + 1) */
    aux = malloc(sizeof(int *) * 2);
    for (i = 0; i < 2; i++) {
        aux[i] = malloc(sizeof(int) * P);
    }
    /* Citeste valorile */
    for (i = 0; i < N; i++) {
        assert(scanf("%d", val + i) == 1);
        assert(1 <= val[i] && val[i] <= P);
    }
    dfs(0, -1);

    printf("%d\n", cnt[0][P - 1]);

    /* Elibereaza memoria alocata */
    for (i = 0; i < N; i++) {
        free(con[i]);
        free(cnt[i]);
    }
    free(cnt);
    free(aux[0]); free(aux[1]);
    free(aux);
    return 0;
}
