/* Perticas Catalin - 60 de puncte */

#include <cstdio>
#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <ctime>

using namespace std;

#define NM 3005
#define MOD 31333
#define PB push_back

vector <int> G[NM], ARB[NM];
int viz[NM], N, P, W[NM][NM], PW[NM][NM], NRN[NM], p2[NM], cost[NM], RNRN[NM];

void formeazaARB(int nod)
{
    viz[nod] = 1;

    for (int i = 0; i < G[nod].size(); ++i)
    {
        int nnod = G[nod][i];
        if (viz[nnod]) continue;
        ARB[nod].PB(nnod);
        formeazaARB(nnod);
    }
}

void getNRN (int nod)
{
    for (int i = 0; i < ARB[nod].size(); ++i)
    {
        int nnod = ARB[nod][i];
        getNRN(nnod);
        NRN[nod] += NRN[nnod];
        RNRN[nod] += RNRN[nnod];
    }

    NRN[nod] += cost[nod];
    ++RNRN[nod];
}

void bagaDIN(int nod)
{
    if (ARB[nod].size() == 0)
    {
        W[nod][cost[nod]] = 1;
        return ;
    }

    for (int i = 0; i < ARB[nod].size(); ++i)
    {
        int nnod = ARB[nod][i];
        bagaDIN (nnod);
    }

    //memset (PW, 0, sizeof(PW));

    int sum = cost[nod];
    int n = ARB[nod].size();

    for (int i = 0; i < n; ++i)
    {
        int nnod = ARB[nod][i];

        int lim = min (P, sum + NRN[nnod]);

        for (int j = cost[nod]; j <= lim; ++j) PW[i+1][j] = 0;

        sum += NRN[nnod];
    }

    PW[0][cost[nod]] = 1;
    sum = cost[nod];

    for (int i = 0; i < n; ++i)
    {
        int nnod = ARB[nod][i];

        if (sum > P) sum = P;

        for (int j = cost[nod]; j <= sum; ++j)
        {
            PW[i+1][j] = (PW[i+1][j] + (PW[i][j] * p2[RNRN[nnod]-1]) % MOD) % MOD;

            int lim = min (NRN[nnod], P-j);

            for (int k = cost[nnod]; k <= lim; ++k)
                PW[i+1][j+k] = (PW[i+1][j+k] + (PW[i][j] * W[nnod][k]) % MOD) % MOD;
        }

        sum += NRN[nnod];
    }

    int lim = min(NRN[nod], P);

    for (int i = cost[nod]; i <= lim; ++i) W[nod][i] = PW[n][i];
}

int main()
{
    int start = clock();

    freopen ("radare.in", "r", stdin);
    freopen ("radare.out", "w", stdout);

    scanf ("%d %d", &N, &P);

    p2[0] = 1;

    for (int i = 1; i <= N; ++i) p2[i] = (p2[i-1] * 2) % MOD;

    for (int i = 1; i < N; ++i)
    {
        int a, b;
        scanf ("%d %d", &a, &b);

        G[a].PB(b);
        G[b].PB(a);
    }

    for (int i = 1; i <= N; ++i) scanf ("%d", &cost[i]);

    formeazaARB(1);
    getNRN(1);
    bagaDIN(1);

    printf ("%d", W[1][P]);

    return 0;
}
